# form_bloc

| Package                                                                            | Pub                                                                                                    |
| ---------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------ |
| [form_bloc](https://github.com/GiancarloCode/form_bloc/tree/master/packages/form_bloc)                 | [![pub package](https://img.shields.io/pub/v/form_bloc.svg)](https://pub.dev/packages/form_bloc)                 |
| [flutter_form_bloc](https://github.com/GiancarloCode/form_bloc/tree/master/packages/flutter_form_bloc)                 | [![pub package](https://img.shields.io/pub/v/flutter_form_bloc.svg)](https://pub.dev/packages/flutter_form_bloc)


Easy Form State Management using BLoC pattern. Separate the Form State and Business Logic from the User Interface.

# [🔥👉 Documentation and Tutorials 👈🔥](https://giancarlocode.github.io/form_bloc/)


- [x] Synchronous Field Validation
- [x] Asynchronous Field Validation
- [x] Easy Loading and Initializing
- [x] Wizard / Stepper Forms
- [x] Submission Progress
- [x] Success / Failure Response
- [x] Serializable Form
- [x] Submission Errors to Fields
- [x] Dynamic Fields
- [x] Conditional Fields
- [x] List Fields
- [x] Group Fields
- [x] CRUD Support
- [x] Beautiful Built-In Widgets


---

## Examples

<div>
    <table>
        <tr>
            <td> 
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc1.gif" width="230"/>
                </a>
            </td>    
            <td>   
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc2.gif" width="230"/>                   
                </a>
            </td>
             <td>   
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc3.gif" width="230"/>                   
                </a>
            </td>        
        </tr>
        <tr>
            <td> 
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc4.gif" width="230"/>
                </a>
            </td>    
            <td>   
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc5.gif" width="230"/>                   
                </a>
            </td>
            <td>   
                <a>
                    <img src="https://raw.githubusercontent.com/GiancarloCode/form_bloc/master/screenshots/form_bloc6.gif" width="230"/>                   
                </a>
            </td>            
        </tr>
    <table>

</div>


## Maintainers

- [GiancarloCode](https://github.com/GiancarloCode)
- [AhmedWahdan](https://github.com/WahdanZ)

